/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the DataSourceDescriptorGroupMutable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &DataSourceDescriptorGroupMutable{}

// DataSourceDescriptorGroupMutable struct for DataSourceDescriptorGroupMutable
type DataSourceDescriptorGroupMutable struct {
	ParentId *string `json:"parent_id,omitempty"`
	Name string `json:"name"`
	Description *string `json:"description,omitempty"`
}

// NewDataSourceDescriptorGroupMutable instantiates a new DataSourceDescriptorGroupMutable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewDataSourceDescriptorGroupMutable(name string) *DataSourceDescriptorGroupMutable {
	this := DataSourceDescriptorGroupMutable{}
	this.Name = name
	return &this
}

// NewDataSourceDescriptorGroupMutableWithDefaults instantiates a new DataSourceDescriptorGroupMutable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewDataSourceDescriptorGroupMutableWithDefaults() *DataSourceDescriptorGroupMutable {
	this := DataSourceDescriptorGroupMutable{}
	return &this
}

// GetParentId returns the ParentId field value if set, zero value otherwise.
func (o *DataSourceDescriptorGroupMutable) GetParentId() string {
	if o == nil || IsNil(o.ParentId) {
		var ret string
		return ret
	}
	return *o.ParentId
}

// GetParentIdOk returns a tuple with the ParentId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorGroupMutable) GetParentIdOk() (*string, bool) {
	if o == nil || IsNil(o.ParentId) {
		return nil, false
	}
	return o.ParentId, true
}

// HasParentId returns a boolean if a field has been set.
func (o *DataSourceDescriptorGroupMutable) HasParentId() bool {
	if o != nil && !IsNil(o.ParentId) {
		return true
	}

	return false
}

// SetParentId gets a reference to the given string and assigns it to the ParentId field.
func (o *DataSourceDescriptorGroupMutable) SetParentId(v string) {
	o.ParentId = &v
}

// GetName returns the Name field value
func (o *DataSourceDescriptorGroupMutable) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorGroupMutable) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *DataSourceDescriptorGroupMutable) SetName(v string) {
	o.Name = v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *DataSourceDescriptorGroupMutable) GetDescription() string {
	if o == nil || IsNil(o.Description) {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorGroupMutable) GetDescriptionOk() (*string, bool) {
	if o == nil || IsNil(o.Description) {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *DataSourceDescriptorGroupMutable) HasDescription() bool {
	if o != nil && !IsNil(o.Description) {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *DataSourceDescriptorGroupMutable) SetDescription(v string) {
	o.Description = &v
}

func (o DataSourceDescriptorGroupMutable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o DataSourceDescriptorGroupMutable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ParentId) {
		toSerialize["parent_id"] = o.ParentId
	}
	toSerialize["name"] = o.Name
	if !IsNil(o.Description) {
		toSerialize["description"] = o.Description
	}
	return toSerialize, nil
}

type NullableDataSourceDescriptorGroupMutable struct {
	value *DataSourceDescriptorGroupMutable
	isSet bool
}

func (v NullableDataSourceDescriptorGroupMutable) Get() *DataSourceDescriptorGroupMutable {
	return v.value
}

func (v *NullableDataSourceDescriptorGroupMutable) Set(val *DataSourceDescriptorGroupMutable) {
	v.value = val
	v.isSet = true
}

func (v NullableDataSourceDescriptorGroupMutable) IsSet() bool {
	return v.isSet
}

func (v *NullableDataSourceDescriptorGroupMutable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDataSourceDescriptorGroupMutable(val *DataSourceDescriptorGroupMutable) *NullableDataSourceDescriptorGroupMutable {
	return &NullableDataSourceDescriptorGroupMutable{value: val, isSet: true}
}

func (v NullableDataSourceDescriptorGroupMutable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDataSourceDescriptorGroupMutable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


